package edu.nyu.scps.thread;

import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;

public class MainActivity extends AppCompatActivity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        Log.d("myTag", "App Process ID: " + android.os.Process.myPid() );

        Thread currentThread = Thread.currentThread();
        Log.d("myTag", "Name of UI thread: " + currentThread.getName());
        Log.d("myTag", "ID of UI thread: " + currentThread.getId());

        Runnable runnable = new Runnable() {
            @Override
            public void run() {
                Thread currentThread = Thread.currentThread();
                Log.d("myTag", "Name of second thread: " + currentThread.getName());
                Log.d("myTag", "ID of second thread: " + currentThread.getId());

                for (int i = 0;; ++i) {
                    Log.d("myTag", String.valueOf(i));
                    try {
                        Thread.sleep(1000L);   //milliseconds
                    } catch (InterruptedException interruptedException) {
                    }
                }
            }
        };

        Thread thread = new Thread(runnable);   //a thread that is not the UI thread
        thread.start();   //The thread will execute the run method of the Runnable object.
    }

    @Override
    protected void onDestroy() {
        Log.d("myTag", "onDestroy");
        super.onDestroy();
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }
}
